# _ const_fold.py ____________________________________________________________________________
# const_fold : a class that subclasifies GraphGrammar. File generated automatically by ATOM3.
# ___________________________________________________________________________________________
from GraphGrammar import *
from fold_operator import *
from del_marked_constants import *
from fold_operator_top import *
class const_fold (GraphGrammar):
   def __init__ (self, parent):
      GraphGrammar.__init__(self, [fold_operator(parent) , del_marked_constants(parent) , fold_operator_top(parent)])
   def initialAction(self, graph):
      # Add the attribute "to_delete" to all "constant" nodes.
      #
      # Constant nodes with this attribute set to True (1) will be deleted
      # by the Graph Grammar rule del_marked_constants (with priority 1).
      # Initially, to_delete is set to False (0) for all constant nodes.
      #
      # "to_delete" is a plain Python attribute, not an AToM3 attribute
      # (it is not present in the meta-model).
      # This approach is taken as we do not want the user to see this attribute
      # when editing a model (which is what would happen if the attribute were
      # present in the meta-model).
      # As "to_delete" is a plain Python attributed, we access its value
      # by self.getMatched(graphID, self.LHS.nodeWithLabel(N)).to_delete
      # and NOT by self.getMatched(graphID, self.LHS.nodeWithLabel(N)).to_delete.getValue()
      # The latter is only necessary to access AToM3 attributes.
      
      for node in graph.listNodes["constant"]:
        node.to_delete = 0
      
      
      
      
      
      
      
      

   def finalAction(self, graph):
      # Remove the helper attribute "to_delete" from all "constant" nodes
      
      for node in graph.listNodes["constant"]:
        del node.to_delete
      
      
      
      
      
      

